<?php

declare(strict_types=1);

namespace Flexlab_Google_Analytics_For_WooCommerce\Traits;

/**
 * Trait to forbid methods when calling from the class.
 */
trait Forbidden
{
    /**
     * Cloning is forbidden.
     */
    public function __clone() 
    {
        _doing_it_wrong( __FUNCTION__, esc_html__( 'Cloning is forbidden.', 'flexlab-google-analytics-for-woocommerce' ), WOOCOMMERCE_GA_VERSION );
    }

    /**
     * Unserializing instances is forbidden.
     */
    public function __wakeup() 
    {
        _doing_it_wrong( __FUNCTION__, esc_html__( 'Unserializing instances is forbidden.', 'flexlab-google-analytics-for-woocommerce' ), WOOCOMMERCE_GA_VERSION );
    }
}
