<?php

declare(strict_types=1);

namespace Flexlab_Google_Analytics_For_WooCommerce\Traits;

/**
 * Trait to instantiate methods from the class.
 */
trait Instance
{
    /**
     * The single instance of the class.
     *
     * @var object
     */
    private static $instance = null;

    /**
     * Main class instance.
     * 
     * Ensures only one instance is instantiated or can be instantiated.
     *
     * @return self
     */
    public static function get_instance() : self
    {
        if ( null === self::$instance ) {
            self::$instance = new self();
        }

        return self::$instance;
    }

    /**
     * Alias to get_instance() method.
     *
     * @return self
     */
    public static function init() : self
    {
        return self::get_instance();
    }
}
